-- CONTADOR DOS DECADAS
-- M.I. BRYAN E ALVAREZ SERNA
-- 7/02/22


LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY contadec IS
	PORT(CLK: IN STD_LOGIC;
		 D, U: BUFFER INTEGER RANGE 0 TO 9);
END ENTITY;

ARCHITECTURE BEAS OF contadec IS
BEGIN

	PROCESS(CLK)
	BEGIN
		IF FALLING_EDGE (CLK) THEN
			IF U = 9 THEN
				U <= 0;
				IF D = 9 THEN
					D <= 0;
				ELSE
					D <= D + 1;
				END IF;
			ELSE
				U <= U + 1;
			END IF;
		END IF;
	END PROCESS;

END BEAS;